#include "huc.h"

#include "standspr.c"
#include "runspr.c"

#define STANDING 0
#define RUNNING  1
#define STRIKING 2

#define RIGHT 0
#define LEFT  1

#define INC_X 2
#define INC_Y 2

const int hero1_stand[22] =
                        {6, /* number of 'posture' for this position */
                         hero1_stand11, /* base adress of the sprites pattern
                                           in the ROM */
                         BANK(hero1_stand11), /* bank in which all the  data are */
                         8, /* number of 32x64 sprite pattern used in this
                               position */
                         0x0000, 0x0200,5, /* posture 1, using first and second
                                               32x64 sprites loaded in VRAM from
                                               hero1_stand11, and lasting 5 vsync */
                         0x0400, 0x0600,5,
                         0x0800, 0x0A00,5,
                         0x0C00, 0x0E00,5,
                         0x0800, 0x0A00,5,
                         0x0400, 0x0600,5};

const int hero1_run[18] =
                        {4, /* number of 'posture' for this position */
                         hero1_run11, /* base adress of the sprites pattern
                                           in the ROM */
                         BANK(hero1_run11), /* bank in which all the  data are */
                         6, /* number of 32x64 sprite pattern used in this
                               position */
                         0x0000, 0x0200,5, /* posture 1, using first and second
                                               32x64 sprites loaded in VRAM from
                                               hero1_stand11, and lasting 5 vsync */
                         0x0400, 0x0600,5,
                         0x0800, 0x0A00,5,
                         0x0400, 0x0600,5};


#define hero1_spr1 0
#define hero1_spr2 1

#define hero1_base_pattern 0x4000

#define player1_pal 0

main ()
{
  char current_posture, current_sprite, current_wait, player1_face;
  char move_player1;
  int dummy1, dummy2, real_x, real_y;
  int *hero1_post;

  init_satb();

  spr_set(hero1_spr1);
  spr_pal(player1_pal);
  spr_pri(1);
  spr_ctrl(SIZE_MAS|FLIP_MAS, SZ_32x64|NO_FLIP);
  spr_x(150);
  spr_y(150);
  spr_pattern(hero1_base_pattern);

  spr_set(hero1_spr2);
  spr_pal(player1_pal);
  spr_pri(1);
  spr_ctrl(SIZE_MAS|FLIP_MAS, SZ_32x64|NO_FLIP);
  spr_x(182);
  spr_y(150);
  spr_pattern(hero1_base_pattern + 0x0200);

  real_x = 100;
  real_y = 100;

/*  hero1_post = hero1_stand; */
  hero1_post = hero1_run;

  dummy1 = hero1_post[1];
  dummy2 = hero1_post[2];
  load_vram2(hero1_base_pattern,
             hero1_post[1],
             hero1_post[2],
             hero1_post[3] << 9);

/*  set_sprpal(0, hero1_stand_pal); */
  set_sprpal(player1_pal, hero1_run_pal);

  current_posture = 0;
  current_sprite = 0;
  current_wait = 0;

  for (;;)
  {

    if (current_wait == 0)
    {
      current_sprite++;
      if (current_sprite == hero1_post[0])
        current_sprite = 0;

      current_wait = hero1_post[6 + current_sprite * 3];

      if (player1_face == RIGHT)
      {  
      spr_set(hero1_spr1);
      spr_pattern(hero1_base_pattern + hero1_post[4 + current_sprite * 3]);

      spr_set(hero1_spr2);
      spr_pattern(hero1_base_pattern + hero1_post[5 + current_sprite * 3]);
      }
      else
      {
      spr_set(hero1_spr1);
      spr_pattern(hero1_base_pattern + hero1_post[4 + current_sprite * 3]);

      spr_set(hero1_spr2);
      spr_pattern(hero1_base_pattern + hero1_post[5 + current_sprite * 3]);

      }

    }
    else
      current_wait--;

    move_player1 = 0;

    satb_update();
    vsync(1); 


    if (joy(0) & JOY_RGHT)
    {

      move_player1 = 1;

      real_x += INC_X;
      player1_face = RIGHT;

      if (hero1_post != hero1_run)
      {
        hero1_post = hero1_run;
        load_vram2(hero1_base_pattern,
             hero1_post[1],
             hero1_post[2],
             hero1_post[3] << 9);
        current_sprite = 0;
        set_sprpal(player1_pal, hero1_run_pal);
      }

    }
    else if (joy(0) & JOY_LEFT)
    {
      move_player1 = 1;

      real_x -= INC_X;
      player1_face = LEFT;

      if (hero1_post != hero1_run)
      {
        hero1_post = hero1_run;
        load_vram2(hero1_base_pattern,
             hero1_post[1],
             hero1_post[2],
             hero1_post[3] << 9);
        current_sprite = 0;
        set_sprpal(player1_pal, hero1_run_pal);
      }

    }

    if (joy(0) & JOY_DOWN)
    {

      move_player1 = 1;

      real_y += INC_Y;
      player1_face = LEFT;

      if (hero1_post != hero1_run)
      {
        hero1_post = hero1_run;
        load_vram2(hero1_base_pattern,
             hero1_post[1],
             hero1_post[2],
             hero1_post[3] << 9);
        current_sprite = 0;
        set_sprpal(player1_pal, hero1_run_pal);
      }

    }
    else if (joy(0) & JOY_UP)
    {
      move_player1 = 1;

      real_y -= INC_Y;
      player1_face = RIGHT;

      if (hero1_post != hero1_run)
      {
        hero1_post = hero1_run;
        load_vram2(hero1_base_pattern,
             hero1_post[1],
             hero1_post[2],
             hero1_post[3] << 9);
        current_sprite = 0;
        set_sprpal(player1_pal, hero1_run_pal);
      }

    }


    if (!move_player1)
    {
      if (hero1_post != hero1_stand)
      {
        hero1_post = hero1_stand;
        load_vram2(hero1_base_pattern,
             hero1_post[1],
             hero1_post[2],
             hero1_post[3] << 9);
        current_sprite = 0;
        set_sprpal(player1_pal, hero1_stand_pal);
      }
    }

    if (player1_face == RIGHT)
    {
      spr_set(hero1_spr1);
      spr_ctrl(FLIP_MAS, NO_FLIP);
      spr_x(real_x - (real_y >> 1));
      spr_y(real_y >> 1);

      spr_set(hero1_spr2);
      spr_ctrl(FLIP_MAS, NO_FLIP);
      spr_x(real_x - (real_y >> 1) + 32);
      spr_y(real_y >> 1);
    }
    else
    {
      spr_set(hero1_spr1);
      spr_ctrl(FLIP_MAS, FLIP_X);
      spr_x(real_x - (real_y >> 1));
      spr_y(real_y >> 1);

      spr_set(hero1_spr2);
      spr_ctrl(FLIP_MAS, FLIP_X);
      spr_x(real_x - (real_y >> 1) - 32);
      spr_y(real_y >> 1);

    }


/*    while (!joytrg(0)); */
  }

}
